#
# This script is automatically generated by XBaya Workflow Composer 2.6.0_1.
#

import sys, thread
from java.lang import Throwable
from java.util import Properties
from java.io import FileInputStream
from javax.xml.namespace import QName
from edu.indiana.extreme.xbaya.jython.lib import GenericInvoker
from edu.indiana.extreme.xbaya.jython.lib import NotificationSender

properties = Properties()

# Set up defaut parameter values.
properties.setProperty(
        'brokerURL',
        'http://tyr11.cs.indiana.edu:12346/')
properties.setProperty(
        'msgBoxURL',
        'http://tyr11.cs.indiana.edu:13333/MsgBox')
properties.setProperty(
        'topic',
        'xbaya-topic')
properties.setProperty(
        'resourceCatalogURL',
        '')
properties.setProperty(
        'gfacRegistryURL',
        '')
properties.setProperty(
        'gfacURL',
        'https://tyr12.cs.indiana.edu:23443/')
properties.setProperty(
        'n',
        '5')

# Set up default WSDL URLs.
properties.setProperty(
        'ArrayGenerator_generate_wsdl',
        '')
properties.setProperty(
        'ArrayAdder_add_wsdl',
        '')

def usage():
    print '''
Options: -f properties_file
         -brokerURL value
         -msgBoxURL value
         -topic value
         -resourceCatalogURL value
         -gfacRegistryURL value
         -gfacURL value
         -n value
         -ArrayGenerator_generate_wsdl value
         -ArrayAdder_add_wsdl value
'''
    sys.exit(0)

# Process command-line arguments.
if sys.argv[0][0] != '-':
    sys.argv = sys.argv[1:]
while sys.argv:
    if sys.argv[0] == '-f':
        # Read parameters from a file.
        propertyFilename = sys.argv[1]
        inputStream = FileInputStream(propertyFilename)
        properties.load(inputStream)
    elif sys.argv[0] == '-brokerURL':
        properties.put('brokerURL', sys.argv[1])
    elif sys.argv[0] == '-msgBoxURL':
        properties.put('msgBoxURL', sys.argv[1])
    elif sys.argv[0] == '-topic':
        properties.put('topic', sys.argv[1])
    elif sys.argv[0] == '-resourceCatalogURL':
        properties.put('resourceCatalogURL', sys.argv[1])
    elif sys.argv[0] == '-gfacRegistryURL':
        properties.put('gfacRegistryURL', sys.argv[1])
    elif sys.argv[0] == '-gfacURL':
        properties.put('gfacURL', sys.argv[1])
    elif sys.argv[0] == '-n':
        properties.put('n', sys.argv[1])
    elif sys.argv[0] == '-ArrayGenerator_generate_wsdl':
        properties.put('ArrayGenerator_generate_wsdl', sys.argv[1])
    elif sys.argv[0] == '-ArrayAdder_add_wsdl':
        properties.put('ArrayAdder_add_wsdl', sys.argv[1])
    else:
        usage()
    sys.argv = sys.argv[2:]

resourceCatalogURL = properties.getProperty('resourceCatalogURL')
gfacRegistryURL = properties.getProperty('gfacRegistryURL')
gfacURL = properties.getProperty('gfacURL')
topic = properties.getProperty('topic')
brokerURL = properties.getProperty('brokerURL')
msgBoxURL = properties.getProperty('msgBoxURL')
notifier = NotificationSender(brokerURL, topic)
notifier.workflowStarted(
    n=properties.getProperty('n'))

try:
    # Invoke ArrayGenerator_generate.
    ArrayGenerator_generate_qname = QName('http://www.extreme.indiana.edu/math/', 'ArrayGenerator')
    ArrayGenerator_generate_wsdl = properties.getProperty('ArrayGenerator_generate_wsdl')
    ArrayGenerator_generate_invoker = GenericInvoker(ArrayGenerator_generate_qname, ArrayGenerator_generate_wsdl, 'ArrayGenerator_generate',
        msgBoxURL, resourceCatalogURL, gfacRegistryURL, gfacURL, notifier)
    def invokeArrayGenerator_generate():
        ArrayGenerator_generate_invoker.setup()
        ArrayGenerator_generate_invoker.setOperation('generate')
        n_value = properties.getProperty('n')
        ArrayGenerator_generate_invoker.setInput('n', n_value)
        print 'Invoking ArrayGenerator_generate.'
        ArrayGenerator_generate_invoker.invoke()
    invokeArrayGenerator_generate()

    # Invoke ArrayAdder_add.
    ArrayAdder_add_qname = QName('http://www.extreme.indiana.edu/math/', 'ArrayAdder')
    ArrayAdder_add_wsdl = properties.getProperty('ArrayAdder_add_wsdl')
    ArrayAdder_add_invoker = GenericInvoker(ArrayAdder_add_qname, ArrayAdder_add_wsdl, 'ArrayAdder_add',
        msgBoxURL, resourceCatalogURL, gfacRegistryURL, gfacURL, notifier)
    def invokeArrayAdder_add():
        ArrayAdder_add_invoker.setup()
        ArrayAdder_add_invoker.setOperation('add')
        input_value = ArrayGenerator_generate_invoker.getOutput('output')
        ArrayAdder_add_invoker.setInput('input', input_value)
        print 'Invoking ArrayAdder_add.'
        ArrayAdder_add_invoker.invoke()
    invokeArrayAdder_add()

    # Wait output sum
    sum_value = ArrayAdder_add_invoker.getOutput('sum')
    print 'sum = ', sum_value

    # Wait all executing services.

    notifier.workflowFinished(
        sum=sum_value)
    print 'Everything is done successfully.'

except Throwable, e:
    print 'Error: ', e
    notifier.workflowFailed(e)
